<script>
import {ContentPageDynamicContentElement} from "./components/ContentPageDynamicContentElement.js";
import ContentPageParagraphText from "./components/ContentPageParagraphText.vue";
import ContentPageParagraphAccordeon from "./components/ContentPageParagraphAccordeon.vue";
import ContentPageParagraphImage from "./components/ContentPageParagraphImage.vue";
import ContentPageParagraphVideo from "./components/ContentPageParagraphVideo.vue";

export default {
  name: "ContentPage",
  components: {
    ContentPageParagraphText,
    ContentPageParagraphAccordeon,
    ContentPageParagraphImage,
    ContentPageParagraphVideo
  },
  mixins: [ContentPageDynamicContentElement],
  props: {
    pageid: {
      type: String,
      required: true
    }
  },
  computed: {
    page () {
      return this.$store.getters.contentPage(this.pageid);
    },
    content () {
      return this.page
        ? this.page.content
        : [];
    },
    isMobile () {
      return this.$root.$data.isMobile;
    }
  },
  created () {
    this.$store.dispatch("contentPage", this.pageid);
  }
};
</script>

<template>
  <div
    class="ContentPage"
    :class="{mobilePage: isMobile}"
  >
    <h1>{{ page.title }}</h1>

    <component
      :is="getComponent(element)"
      v-for="(element, index) in content"
      :key="getComponent(element) + '-' + index"
      :content="element"
    />

    <router-link
      to="/"
      class="rootLink"
    >
      zurück zum navigator
    </router-link>
  </div>
</template>

<style lang="scss">
@import "../../scss/_global.scss";

div.ContentPage {
  margin: 5vh 10vw;
  hyphens: auto;
  -moz-hyphens: auto;
  -o-hyphens: auto;
  -webkit-hyphens: auto;
  -ms-hyphens: auto;

  &.mobilePage {
    margin: 5vh 2vw;
  }

  h1 {
    @extend %fontdefinition_headline_1;
  }

  a.rootLink {
    display: block;
    margin-top: 30px;

    &:before {
      content: "<<<";
      display: inline-block;
      margin-right: 5px;
    }
  }
}
</style>
